`default_nettype	none
`timescale			1ns/1ps
/* -----------------------------------------------------------------
	CX-Card4 System Controller		TAB = 4;
	Verilog-HDL Version

	Synthesis & Fitter tool = "QuartusII10.0+SP1"

	FileName = GPIF_SOPC_Verilog.v
	
	M.YOSHIDA				16.SEP.2010		REV	0.0
----------------------------------------------------------------- */
//	Define Declaration
//	Module Declaration
module	QSYS_Verilog		(	ifclk1,				//	System clock 48MHz input
								rstn,				//	Active low reset input

								fd,					//	GPIF Bidirectional data bus
								rdn,
								wrn,
								cmdn,
								rgdtn,
								rdy,
								linkn,
								crc_in,
								
								sram_ab,
								sram_db,
								sram_csn,
								sram_wen,
								sram_oen,

								led,

								dipsw,				//	DIPSW input
								psw,

								
								dummy

						);

	//	Parameter  Declaration
	`include	"..\Param.v"
	
	//	Port declaration
	//	System Port
	input							ifclk1;
	input							rstn;
	
	//	GPIF Port
	inout	[15:0]					fd;
	input							rdn;
	input							wrn;
	input							cmdn;
	input							rgdtn;
	output							rdy;
	input							linkn;
	input							crc_in;

	//	Async-SRAM Port
	output	[MEM_LENGTH-1:0]		sram_ab;
	inout	[7:0]					sram_db;
	output							sram_csn;
	output							sram_wen;
	output							sram_oen;
	
	//	Switch Port
	input	[4:1]					dipsw;
	input							psw;
	
	//	LED & 7SEG-LED
	output	[3:0]					led;

	
	
	output							dummy;
	
	wire							pll_clk;
	wire							pll_locked;
	wire	[7:0]					led_wire;
	wire	[5:0]					rdy_wire;
	
	Pll					pll1	(	.inclk0( ifclk1 ),
									.areset( !rstn ),
									.c0( pll_clk ),
									.locked( pll_locked )
								);

    QSYS_top			qsys1	(	.clk_0_clk( pll_clk ),
									.reset_0_reset_n( !( !rstn | !pll_locked )),
									.gpif_master_0_conduit_end_fd( fd ),
									.gpif_master_0_conduit_end_ctl({ 1'b0, 1'b0, rgdtn, cmdn, wrn, rdn }),
									.gpif_master_0_conduit_end_rdy( rdy_wire ),

									.sram_conduit_end_ab( sram_ab ),
									.sram_conduit_end_db( sram_db ),
									.sram_conduit_end_csn( sram_csn ),
									.sram_conduit_end_wen( sram_wen ),
									.sram_conduit_end_oen( sram_oen ),
		
									.notuse_external_connection_export(),
									.led_external_connection_export( led_wire ),
									.swin_external_connection_export( ~{ 3'b111, psw, dipsw }),
									.pio_0_external_connection_export()
									
								);
	
	assign	rdy		=	rdy_wire[0];


	assign	dummy	=	linkn | ( rdy_wire == 0 ) | crc_in;
	assign	led		=	~( led_wire[3:0] );
	
endmodule
